#include<stdio.h>
#include<math.h>

double lagrange(double x, double xw[], double yw[], int n)
{
   double y = 0.0, l, m, xi;
   int i, j;

   for (i = 0; i <= n; i++)
   {
      l = 1.0;
      m = 1.0;
      xi = xw[i];
      for (j = 0; j <= n; j++)
      {
         if (i == j) continue;
         l *= x - xw[j];
         m *= xi - xw[j];
      }
      y += yw[i] * l / m;
   }
   return y;
}


double f1(double x)
{
   // return 100 * x * x * exp(-10 * x);
   return 1.0 / (1.0 + x * x);
}

#define MAX  1000

int main()
{
   double a, b;
   int m, n;

   printf("a=");  scanf("%lf", &a);
   printf("b=");  scanf("%lf", &b);
   printf("n=");  scanf("%d", &n);
   printf("m=");  scanf("%d", &m);

   double h = (b-a)/n;
   double xw[MAX], yw[MAX];

   for (int i = 0; i <= n; i++)
   {
      xw[i] = a + i * h;
      yw[i] = f1(xw[i]);
   }

   h = (b-a)/m;
      
   double x, y1, y2;
   for (int i = 0; i <= m; i++)
   {
      x = a + i * h;

      y1 = lagrange(x, xw, yw, n);
      y2 = f1(x);
      printf("%10.8lf %10.8lf %10.8lf %10.2f %%\n", x, y1, y2, 100.0*fabs(y1-y2)/y2);
   }
}

